package b4a.example.adp;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example.adp", "b4a.example.adp.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example.adp", "b4a.example.adp.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.adp.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static long _sdate = 0L;
public static long _edate = 0L;
public static anywheresoftware.b4a.objects.collections.Map _curcoursevalues = null;
public static anywheresoftware.b4a.objects.collections.Map _cursubvalues = null;
public b4a.example.adp.anotherdatepicker _adp = null;
public b4a.example.adp.viewmgr _vm = null;
public b4a.example.adp.viewmgr _vm1 = null;
public b4a.example.adp.viewmgr _vm2 = null;
public b4a.example.adp.viewmgr _vm3 = null;
public b4a.example.adp.viewmgr _vm4 = null;
public static String _datetext = "";
public static String _datetext1 = "";
public anywheresoftware.b4a.objects.PanelWrapper _spanel = null;
public anywheresoftware.b4a.objects.PanelWrapper _dpanel = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _svstatic = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _svdynamic = null;
public b4a.example.adp.dateutils _dateutils = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 36;BA.debugLine="If FirstTime = True Then";
if (_firsttime==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 37;BA.debugLine="curCourseValues.Initialize";
_curcoursevalues.Initialize();
 //BA.debugLineNum = 38;BA.debugLine="curSubValues.Initialize";
_cursubvalues.Initialize();
 };
 //BA.debugLineNum = 41;BA.debugLine="adp.Initialize";
mostCurrent._adp._initialize(mostCurrent.activityBA);
 //BA.debugLineNum = 43;BA.debugLine="DateTime.TimeFormat = \"yyyy-MM-dd HH:mm\"";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat("yyyy-MM-dd HH:mm");
 //BA.debugLineNum = 44;BA.debugLine="DateTime.DateFormat = \"MM/dd/yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("MM/dd/yyyy");
 //BA.debugLineNum = 46;BA.debugLine="sDate = DateTime.Now";
_sdate = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 47;BA.debugLine="eDate = DateTime.Now";
_edate = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 49;BA.debugLine="If sDate = 9223372036854775807 Then DateText= \"N/A\" Else DateText= DateTime.date(sDate)";
if (_sdate==9223372036854775807L) { 
mostCurrent._datetext = "N/A";}
else {
mostCurrent._datetext = anywheresoftware.b4a.keywords.Common.DateTime.Date(_sdate);};
 //BA.debugLineNum = 50;BA.debugLine="If eDate = 9223372036854775807 Then DateText1= \"N/A\" Else DateText1= DateTime.date(eDate)";
if (_edate==9223372036854775807L) { 
mostCurrent._datetext1 = "N/A";}
else {
mostCurrent._datetext1 = anywheresoftware.b4a.keywords.Common.DateTime.Date(_edate);};
 //BA.debugLineNum = 53;BA.debugLine="dPanel.Initialize(\"dPanel\") ' <-- dynamic view";
mostCurrent._dpanel.Initialize(mostCurrent.activityBA,"dPanel");
 //BA.debugLineNum = 54;BA.debugLine="Activity.AddView(dPanel, 0, 0dip, 100%x, 100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._dpanel.getObject()),(int) (0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (0)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 55;BA.debugLine="dPanel.Color = Colors.RGB(150,120, 073) ' Navajo White1";
mostCurrent._dpanel.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (150),(int) (120),(int) (073)));
 //BA.debugLineNum = 56;BA.debugLine="svDynamic.Initialize(dPanel.Height+120dip)";
mostCurrent._svdynamic.Initialize(mostCurrent.activityBA,(int) (mostCurrent._dpanel.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (120))));
 //BA.debugLineNum = 57;BA.debugLine="dPanel.AddView(svDynamic, 0, 0, dPanel.Width, dPanel.Height)";
mostCurrent._dpanel.AddView((android.view.View)(mostCurrent._svdynamic.getObject()),(int) (0),(int) (0),mostCurrent._dpanel.getWidth(),mostCurrent._dpanel.getHeight());
 //BA.debugLineNum = 58;BA.debugLine="VM4.Initialize(svDynamic.Panel,dPanel.Width, True, True, True)";
mostCurrent._vm4._initialize(mostCurrent.activityBA,mostCurrent._svdynamic.getPanel(),mostCurrent._dpanel.getWidth(),anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 61;BA.debugLine="sPanel.Initialize(\"sPanel\") ' <-- static view";
mostCurrent._spanel.Initialize(mostCurrent.activityBA,"sPanel");
 //BA.debugLineNum = 62;BA.debugLine="Activity.AddView(sPanel, 0, 0dip, 100%x, 100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._spanel.getObject()),(int) (0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (0)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 63;BA.debugLine="sPanel.Color = Colors.RGB(255,222, 073) ' Navajo White1";
mostCurrent._spanel.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (255),(int) (222),(int) (073)));
 //BA.debugLineNum = 64;BA.debugLine="svStatic.Initialize(sPanel.Height+120dip)";
mostCurrent._svstatic.Initialize(mostCurrent.activityBA,(int) (mostCurrent._spanel.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (120))));
 //BA.debugLineNum = 65;BA.debugLine="sPanel.AddView(svStatic, 0, 0, sPanel.Width, sPanel.Height)";
mostCurrent._spanel.AddView((android.view.View)(mostCurrent._svstatic.getObject()),(int) (0),(int) (0),mostCurrent._spanel.getWidth(),mostCurrent._spanel.getHeight());
 //BA.debugLineNum = 66;BA.debugLine="VM1.Initialize(svStatic.Panel, svStatic.Width, True, True, True)";
mostCurrent._vm1._initialize(mostCurrent.activityBA,mostCurrent._svstatic.getPanel(),mostCurrent._svstatic.getWidth(),anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 68;BA.debugLine="VM1.Padding = 8dip";
mostCurrent._vm1._padding = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (8));
 //BA.debugLineNum = 69;BA.debugLine="VM1.AddLabel(VM1.Padding, -1, 1, 1,  \"Please Fill Following Details:------->\", 18, Colors.Black, False)";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-1),(int) (1),(int) (1),"Please Fill Following Details:------->",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,BA.ObjectToString(anywheresoftware.b4a.keywords.Common.False));
 //BA.debugLineNum = 70;BA.debugLine="VM1.AddLabel(VM1.Padding, -2, 1,   1, \"Course Name:\", 18, Colors.Black, \"CourseName\")";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-2),(int) (1),(int) (1),"Course Name:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"CourseName");
 //BA.debugLineNum = 71;BA.debugLine="VM1.AddTextBox(140dip, -1, -1, 1,  \"CourseName\", \"\", 18, \"Course Name (like BCA-IT)\", False, VM1.DataType_Text, \"\", VM1.ActionBtn_Next, \"\", Me, 5, 30,  Null)";
mostCurrent._vm1._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-1),(int) (1),"CourseName","",(float) (18),"Course Name (like BCA-IT)",anywheresoftware.b4a.keywords.Common.False,mostCurrent._vm1._datatype_text(),"",mostCurrent._vm1._actionbtn_next(),"",main.getObject(),(int) (5),(int) (30),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 72;BA.debugLine="VM1.AddLabel(VM1.Padding, -2, 1, 1, \"Course ID:\", 18, Colors.Black, \"CourseID\")";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-2),(int) (1),(int) (1),"Course ID:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"CourseID");
 //BA.debugLineNum = 73;BA.debugLine="VM1.AddTextBox(140dip, -1, -1, 1, \"CourseID\", \"\", 18, \"Course ID (like BCA-14D14-2)\", False, VM1.DataType_Text, \"\", VM1.ActionBtn_Next, \"\", Me, 10, 30, Null)";
mostCurrent._vm1._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-1),(int) (1),"CourseID","",(float) (18),"Course ID (like BCA-14D14-2)",anywheresoftware.b4a.keywords.Common.False,mostCurrent._vm1._datatype_text(),"",mostCurrent._vm1._actionbtn_next(),"",main.getObject(),(int) (10),(int) (30),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 75;BA.debugLine="VM1.AddLabel(VM1.Padding, -2, 1, 1, \"Start Date:\", 18, Colors.Black, \"sDate\")";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-2),(int) (1),(int) (1),"Start Date:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"sDate");
 //BA.debugLineNum = 76;BA.debugLine="VM1.AddTextBox(140dip, -1, -50, 1, \"sDate\",  DateText, 18, \"\", False, 0, \"\",0, \"\", Me, 0, 10, Null)";
mostCurrent._vm1._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-50),(int) (1),"sDate",mostCurrent._datetext,(float) (18),"",anywheresoftware.b4a.keywords.Common.False,(int) (0),"",(int) (0),"",main.getObject(),(int) (0),(int) (10),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 77;BA.debugLine="VM1.Enabled(\"sDate\",  False)";
mostCurrent._vm1._enabled("sDate",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 79;BA.debugLine="adp.AddToActivity(Activity, VM1.GetView(\"sDate\"))";
mostCurrent._adp._addtoactivity(mostCurrent._activity,(anywheresoftware.b4a.objects.EditTextWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.EditTextWrapper(), (android.widget.EditText)(mostCurrent._vm1._getview("sDate").getObject())));
 //BA.debugLineNum = 80;BA.debugLine="VM1.AddButton(-2, -1, -1, 1, \"sDateBtn\", \"Set Date\", 16, Colors.Black, \"sDate_Click\", Me)";
mostCurrent._vm1._addbutton((int) (-2),(int) (-1),(int) (-1),(int) (1),"sDateBtn","Set Date",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"sDate_Click",main.getObject());
 //BA.debugLineNum = 82;BA.debugLine="VM1.AddLabel(VM1.Padding, -2, 1, 1, \"End Date:\", 18, Colors.Black, \"eDate\")";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-2),(int) (1),(int) (1),"End Date:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"eDate");
 //BA.debugLineNum = 83;BA.debugLine="VM1.AddTextBox(140dip, -1, -50, 1, \"eDate\", DateText1, 18, \"\", False, 0, \"\",0, \"\", Me, 0, 10, Null)";
mostCurrent._vm1._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-50),(int) (1),"eDate",mostCurrent._datetext1,(float) (18),"",anywheresoftware.b4a.keywords.Common.False,(int) (0),"",(int) (0),"",main.getObject(),(int) (0),(int) (10),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 84;BA.debugLine="VM1.Enabled(\"eDate\", False)";
mostCurrent._vm1._enabled("eDate",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 86;BA.debugLine="adp.AddToActivity(Activity, VM1.GetView(\"eDate\"))";
mostCurrent._adp._addtoactivity(mostCurrent._activity,(anywheresoftware.b4a.objects.EditTextWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.EditTextWrapper(), (android.widget.EditText)(mostCurrent._vm1._getview("eDate").getObject())));
 //BA.debugLineNum = 88;BA.debugLine="VM1.AddButton(-2, -1, -1, 1, \"eDateBtn\", \"Set Date\", 16, Colors.Black, \"eDate_Click\", Me)";
mostCurrent._vm1._addbutton((int) (-2),(int) (-1),(int) (-1),(int) (1),"eDateBtn","Set Date",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"eDate_Click",main.getObject());
 //BA.debugLineNum = 90;BA.debugLine="VM1.AddLabel(VM1.Padding, -2, 1, 1, \"Subjects :\", 18, Colors.Black, \"numSubjects\")";
mostCurrent._vm1._addlabel(mostCurrent._vm1._padding,(int) (-2),(int) (1),(int) (1),"Subjects :",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"numSubjects");
 //BA.debugLineNum = 91;BA.debugLine="VM1.AddComboBox(140dip, -1, -90, 1,  \"numSubjects\", \"Numbers of Subjects\", File.ReadList(File.DirAssets, \"num.txt\"), 18, Colors.Black, \"\", Me, 10)";
mostCurrent._vm1._addcombobox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-90),(int) (1),"numSubjects","Numbers of Subjects",anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"num.txt"),(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"",main.getObject(),(int) (10));
 //BA.debugLineNum = 93;BA.debugLine="VM1.AddButton(sPanel.Width-150dip,  -2, -1, 1,   \"courseConfirm\", \"Confirm\", 16, Colors.Black, \"Course_Confirm_Click\", Me)";
mostCurrent._vm1._addbutton((int) (mostCurrent._spanel.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (150))),(int) (-2),(int) (-1),(int) (1),"courseConfirm","Confirm",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"Course_Confirm_Click",main.getObject());
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 101;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 103;BA.debugLine="If curCourseValues.IsInitialized Then VM1.RestoreState(curCourseValues)";
if (_curcoursevalues.IsInitialized()) { 
mostCurrent._vm1._restorestate(_curcoursevalues);};
 //BA.debugLineNum = 104;BA.debugLine="If curSubValues.IsInitialized Then VM4.RestoreState(curSubValues)";
if (_cursubvalues.IsInitialized()) { 
mostCurrent._vm4._restorestate(_cursubvalues);};
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static String  _course_confirm_click() throws Exception{
 //BA.debugLineNum = 149;BA.debugLine="Sub Course_Confirm_Click";
 //BA.debugLineNum = 150;BA.debugLine="removeAllViews(dPanel, True)";
_removeallviews(mostCurrent._dpanel,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 151;BA.debugLine="createChapters (5)";
_createchapters((int) (5));
 //BA.debugLineNum = 152;BA.debugLine="End Sub";
return "";
}
public static String  _createchapters(int _nt) throws Exception{
int _y = 0;
 //BA.debugLineNum = 113;BA.debugLine="Sub createChapters (nt As Int)";
 //BA.debugLineNum = 114;BA.debugLine="sPanel.SendToBack";
mostCurrent._spanel.SendToBack();
 //BA.debugLineNum = 115;BA.debugLine="Log(\"created chapters\")";
anywheresoftware.b4a.keywords.Common.Log("created chapters");
 //BA.debugLineNum = 116;BA.debugLine="dPanel.Color = Colors.RGB(255,222, 073) ' Navajo White1";
mostCurrent._dpanel.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (255),(int) (222),(int) (073)));
 //BA.debugLineNum = 117;BA.debugLine="svDynamic.Initialize(dPanel.Height+120dip)";
mostCurrent._svdynamic.Initialize(mostCurrent.activityBA,(int) (mostCurrent._dpanel.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (120))));
 //BA.debugLineNum = 118;BA.debugLine="dPanel.AddView(svDynamic, 0, 0, dPanel.Width, dPanel.Height)";
mostCurrent._dpanel.AddView((android.view.View)(mostCurrent._svdynamic.getObject()),(int) (0),(int) (0),mostCurrent._dpanel.getWidth(),mostCurrent._dpanel.getHeight());
 //BA.debugLineNum = 119;BA.debugLine="VM4.Initialize(svDynamic.Panel,dPanel.Width, True, True, True)";
mostCurrent._vm4._initialize(mostCurrent.activityBA,mostCurrent._svdynamic.getPanel(),mostCurrent._dpanel.getWidth(),anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 122;BA.debugLine="VM4.Padding = 8dip";
mostCurrent._vm4._padding = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (8));
 //BA.debugLineNum = 124;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1,  1, \"Add Chapter Names \", 18, Colors.Black,  \"\")";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"Add Chapter Names ",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"");
 //BA.debugLineNum = 126;BA.debugLine="For y = 0 To nt-1";
{
final int step71 = 1;
final int limit71 = (int) (_nt-1);
for (_y = (int) (0); (step71 > 0 && _y <= limit71) || (step71 < 0 && _y >= limit71); _y = ((int)(0 + _y + step71))) {
 //BA.debugLineNum = 128;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1,   1,\"Subject Name:\" , 18, Colors.Black,\"\" )";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"Subject Name:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"");
 //BA.debugLineNum = 129;BA.debugLine="VM4.AddLabel(140, -1, -1,   1,\"subjectNum\"&y, 18, Colors.Blue,\"\" )";
mostCurrent._vm4._addlabel((int) (140),(int) (-1),(int) (-1),(int) (1),"subjectNum"+BA.NumberToString(_y),(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Blue,"");
 //BA.debugLineNum = 130;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1, 1,  \"=======================================================\", 18, Colors.Red, False)";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"=======================================================",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Red,BA.ObjectToString(anywheresoftware.b4a.keywords.Common.False));
 //BA.debugLineNum = 131;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1, 1, \"Start Date:\", 18, Colors.Black, \"sDate\"&y)";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"Start Date:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"sDate"+BA.NumberToString(_y));
 //BA.debugLineNum = 132;BA.debugLine="VM4.AddTextBox(140dip, -1, -50, 1, \"sDate\"&y,  DateText, 18, \"\", False, 0, \"\",0, \"\", Me, 0, 10, Null)";
mostCurrent._vm4._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-50),(int) (1),"sDate"+BA.NumberToString(_y),mostCurrent._datetext,(float) (18),"",anywheresoftware.b4a.keywords.Common.False,(int) (0),"",(int) (0),"",main.getObject(),(int) (0),(int) (10),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 133;BA.debugLine="VM4.Enabled(\"sDate\"&y,  False)";
mostCurrent._vm4._enabled("sDate"+BA.NumberToString(_y),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 134;BA.debugLine="adp.AddToActivity(Activity, VM4.GetView(\"sDate\"&y))";
mostCurrent._adp._addtoactivity(mostCurrent._activity,(anywheresoftware.b4a.objects.EditTextWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.EditTextWrapper(), (android.widget.EditText)(mostCurrent._vm4._getview("sDate"+BA.NumberToString(_y)).getObject())));
 //BA.debugLineNum = 135;BA.debugLine="VM4.AddButton(-2, -1, -1, 1, \"sDateBtn\"&y, \"Set Date\", 16, Colors.Black, \"sDate_Click\", Me)";
mostCurrent._vm4._addbutton((int) (-2),(int) (-1),(int) (-1),(int) (1),"sDateBtn"+BA.NumberToString(_y),"Set Date",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"sDate_Click",main.getObject());
 //BA.debugLineNum = 136;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1, 1, \"End Date:\", 18, Colors.Black, \"eDate\"&y)";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"End Date:",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Black,"eDate"+BA.NumberToString(_y));
 //BA.debugLineNum = 137;BA.debugLine="VM4.AddTextBox(140dip, -1, -50, 1, \"eDate\"&y,  DateText1, 18, \"\", False, 0, \"\",0, \"\", Me, 0, 10, Null)";
mostCurrent._vm4._addtextbox(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (140)),(int) (-1),(int) (-50),(int) (1),"eDate"+BA.NumberToString(_y),mostCurrent._datetext1,(float) (18),"",anywheresoftware.b4a.keywords.Common.False,(int) (0),"",(int) (0),"",main.getObject(),(int) (0),(int) (10),(anywheresoftware.b4a.objects.collections.List) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.collections.List(), (java.util.List)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 138;BA.debugLine="VM4.Enabled(\"eDate\"&y,  False)";
mostCurrent._vm4._enabled("eDate"+BA.NumberToString(_y),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 139;BA.debugLine="adp.AddToActivity(Activity, VM4.GetView(\"eDate\"&y))";
mostCurrent._adp._addtoactivity(mostCurrent._activity,(anywheresoftware.b4a.objects.EditTextWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.EditTextWrapper(), (android.widget.EditText)(mostCurrent._vm4._getview("eDate"+BA.NumberToString(_y)).getObject())));
 //BA.debugLineNum = 140;BA.debugLine="VM4.AddButton(-2, -1, -1, 1, \"eDateBtn\"&y, \"Set Date\", 16, Colors.Black, \"eDate_Click\", Me)";
mostCurrent._vm4._addbutton((int) (-2),(int) (-1),(int) (-1),(int) (1),"eDateBtn"+BA.NumberToString(_y),"Set Date",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"eDate_Click",main.getObject());
 }
};
 //BA.debugLineNum = 144;BA.debugLine="VM4.AddButton(dPanel.Width-150dip,  -2, -1, 1,\"topicConfirm\", \"Confirm\", 16, Colors.Black, \"Topic_Confirm_Click\", Me)";
mostCurrent._vm4._addbutton((int) (mostCurrent._dpanel.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (150))),(int) (-2),(int) (-1),(int) (1),"topicConfirm","Confirm",(float) (16),anywheresoftware.b4a.keywords.Common.Colors.Black,"Topic_Confirm_Click",main.getObject());
 //BA.debugLineNum = 145;BA.debugLine="VM4.AddLabel(VM4.Padding, -2, 1, 1,  \"=======================================================\", 18, Colors.Red, False)";
mostCurrent._vm4._addlabel(mostCurrent._vm4._padding,(int) (-2),(int) (1),(int) (1),"=======================================================",(float) (18),anywheresoftware.b4a.keywords.Common.Colors.Red,BA.ObjectToString(anywheresoftware.b4a.keywords.Common.False));
 //BA.debugLineNum = 148;BA.debugLine="End Sub";
return "";
}
public static String  _edate_click() throws Exception{
 //BA.debugLineNum = 167;BA.debugLine="Sub eDate_Click";
 //BA.debugLineNum = 168;BA.debugLine="adp.Show";
mostCurrent._adp._show();
 //BA.debugLineNum = 169;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
dateutils._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Dim adp As AnotherDatePicker ' adp1, adp2.adp3,... < do i need single or mutiple?";
mostCurrent._adp = new b4a.example.adp.anotherdatepicker();
 //BA.debugLineNum = 27;BA.debugLine="Dim VM,VM1,VM2,VM3,VM4 As ViewMgr";
mostCurrent._vm = new b4a.example.adp.viewmgr();
mostCurrent._vm1 = new b4a.example.adp.viewmgr();
mostCurrent._vm2 = new b4a.example.adp.viewmgr();
mostCurrent._vm3 = new b4a.example.adp.viewmgr();
mostCurrent._vm4 = new b4a.example.adp.viewmgr();
 //BA.debugLineNum = 28;BA.debugLine="Dim DateText,DateText1 As String";
mostCurrent._datetext = "";
mostCurrent._datetext1 = "";
 //BA.debugLineNum = 29;BA.debugLine="Dim sPanel, dPanel As Panel";
mostCurrent._spanel = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._dpanel = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim svStatic, svDynamic As ScrollView";
mostCurrent._svstatic = new anywheresoftware.b4a.objects.ScrollViewWrapper();
mostCurrent._svdynamic = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim sDate As Long";
_sdate = 0L;
 //BA.debugLineNum = 19;BA.debugLine="Dim eDate As Long";
_edate = 0L;
 //BA.debugLineNum = 20;BA.debugLine="Dim curCourseValues,curSubValues As Map";
_curcoursevalues = new anywheresoftware.b4a.objects.collections.Map();
_cursubvalues = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _removeallviews(anywheresoftware.b4a.objects.PanelWrapper _p,boolean _enabled) throws Exception{
anywheresoftware.b4a.objects.ConcreteViewWrapper _v = null;
 //BA.debugLineNum = 156;BA.debugLine="Sub removeAllViews (p As Panel, Enabled As Boolean)";
 //BA.debugLineNum = 157;BA.debugLine="For Each v As View In p";
_v = new anywheresoftware.b4a.objects.ConcreteViewWrapper();
final anywheresoftware.b4a.BA.IterableList group97 = _p;
final int groupLen97 = group97.getSize();
for (int index97 = 0;index97 < groupLen97 ;index97++){
_v.setObject((android.view.View)(group97.Get(index97)));
 //BA.debugLineNum = 158;BA.debugLine="p.removeAllViews";
_p.RemoveAllViews();
 }
;
 //BA.debugLineNum = 161;BA.debugLine="End Sub";
return "";
}
public static String  _sdate_click() throws Exception{
 //BA.debugLineNum = 163;BA.debugLine="Sub sDate_Click";
 //BA.debugLineNum = 164;BA.debugLine="adp.Show";
mostCurrent._adp._show();
 //BA.debugLineNum = 165;BA.debugLine="End Sub";
return "";
}
public static String  _topic_confirm_click() throws Exception{
 //BA.debugLineNum = 153;BA.debugLine="Sub Topic_Confirm_Click";
 //BA.debugLineNum = 154;BA.debugLine="sPanel.BringToFront";
mostCurrent._spanel.BringToFront();
 //BA.debugLineNum = 155;BA.debugLine="End Sub";
return "";
}
}
